
#include <pthread.h>
#include <stdio.h>

typedef struct paramS1
  {
   int a;
   int x;
   int y;  
  }paramS1_t;

typedef struct paramS2
  {
   int b;
   int z;
  }paramS2_t;

typedef struct paramS3
  {
   int c;
   pthread_t h1;
   pthread_t h2;
   paramS1_t *msgS1;
   paramS2_t *msgS2;
  }paramS3_t;

typedef struct paramS4
{
 int w;
 pthread_t h3;
 paramS3_t *msgS3;    
}paramS4_t;

void * funcionS1(void *puntero)
  {
    paramS1_t *datos;
    datos=(paramS1_t *)puntero;
    datos->a=(datos->x)+(datos->y); 
    printf("\n   a= %d\n",datos->a);
    pthread_exit(0);
  }
  
void * funcionS2(void *puntero)
  {
    paramS2_t *datos;
    datos=(paramS2_t *)puntero;
    datos->b=(datos->z)-1; 
    printf("\n   b= %d\n",datos->b);
    pthread_exit(0);  
  }

void * funcionS3(void *puntero)
   {
    paramS3_t *datos;
    datos=(paramS3_t *)puntero;
    
    if(datos->h1 !=0)
       pthread_join(datos->h1,NULL);
    if(datos->h2 !=0)
       pthread_join(datos->h2,NULL);
    datos->c=(datos->msgS1->a)-(datos->msgS2->b);
    printf("\n   c= %d\n",datos->c);
    pthread_exit(0);
   }

void * funcionS4(void *puntero)
  {
   paramS4_t *datos;
   
   datos=(paramS4_t *)puntero;
   
   if(datos->h3 !=0)
       pthread_join(datos->h3,NULL);
   datos->w=(datos->msgS3->c)+1;
   printf("\n   w= %d\n",datos->w);
    pthread_exit(0); 
  }

int main(void)
{
 int x=1,y=2,z=3;
 
 
 paramS1_t msgS1={0,x,y};
 paramS2_t msgS2={0,z};
 paramS3_t msgS3={0,0,0,&msgS1,&msgS2};
 paramS4_t msgS4={0,0,&msgS3};
 
 pthread_t s1,s2,s3,s4;
 
 pthread_create(&s1,NULL,funcionS1,(void *)&msgS1);
 pthread_create(&s2,NULL,funcionS2,(void *)&msgS2);
 
 msgS3.h1=s1;
 msgS3.h2=s2;
 
 pthread_create(&s3,NULL,funcionS3,(void *)&msgS3);
 msgS4.h3=s3;
 pthread_create(&s4,NULL,funcionS4,(void *)&msgS4);
 
 pthread_join(s4,NULL);
 system("pause");
}
